﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Public codefolder As String
	Private fchoose As FileChooser
	Private clv1 As CustomListView
	Private itemcnt As Int = 0
	Private ta1 As TextArea
	Private DragAndDrop1 As DragAndDrop
	Private selectedindex As Int
	Private is_selected As Boolean
	Private btnload As Button
	Private btnsave As Button
	Private btnclear As Button
	Private btnadd As Button
	Private btndel As Button
	Private dragger As CLVDragger
	Private lblfilename As Label
	Public btngo As Button
	Public tffind As TextField
	Public tfreplace As TextField
End Sub
Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me,"Code selector")
	DragAndDrop1.Initialize(Me)
	xui.SetDataFolder("code_selector")
	File.MakeDir(xui.DefaultFolder,"codefiles")
	codefolder = File.DirData("code_selector") & "\codefiles"
	fchoose.Initialize
	is_selected = False
	lblfilename.Text = ""
	dragger.Initialize(clv1)
	dragger.AddDragButtons
End Sub
Private Sub set_clv1_item(strlayout As String) As Pane
	Dim pn As Pane
	pn.Initialize("")
	pn.LoadLayout(strlayout)
	pn.SetLayoutAnimated(0, 0, 0, ta1.Width,ta1.Height)
	Return pn
End Sub
private Sub add_item(strtext As String)
	Dim pnl As Pane = set_clv1_item("clv1item_layout")
	pnl.PrefHeight = 150
	pnl.PrefWidth = pnl.Width
	ta1.Text = strtext
	ta1.Tag = itemcnt
	btngo.Tag = itemcnt
	selectedindex = itemcnt
	DragAndDrop1.MakeDragSource(ta1,"ta1Source")
	clv1.InsertAt(0,pnl,itemcnt)
	clv1_reindex
	itemcnt = itemcnt + 1
	is_selected = False
End Sub
Public Sub clv1_reindex
	For i = 0 To clv1.Size -1
		clv1.GetPanel(i).GetView(0).Tag = i
		clv1.GetPanel(i).GetView(4).Tag = i
		clv1.GetPanel(i).Color = xui.Color_ARGB(255,210,210,255)
	Next
	dragger.Initialize(clv1)
	dragger.AddDragButtons
	itemcnt = clv1.Size -1
	selectedindex = itemcnt
	is_selected = False
End Sub
Private Sub clv1_ItemClick (Index As Int, Value As Object)
	selectedindex = Index
End Sub
Sub ta1Source_DragDetected(e As MouseEvent)
	Dim jo As JavaObject = e
	Dim target As JavaObject = jo.RunMethod("getTarget", Null)
	If GetType(target) = "javafx.scene.text.Text" Then
		Dim text As String = target.RunMethod("getText", Null)
	End If
	Dim ta As TextArea
	ta.Initialize("")
	ta.Text = text.Trim
	DragAndDrop1.SetDragModeAndData2(TransferMode.ANY, Array As String("text/plain"), Array As Object(ta.text), ta.Snapshot)
End Sub
Sub ta1Source_DragDone(e As DragEvent)
	is_selected = False
	clv1.GetPanel(selectedindex).Color = xui.Color_ARGB(255,210,210,255)	
End Sub
Private Sub ta1_MouseClicked (EventData As MouseEvent)
	Dim ta As TextArea = Sender
	selectedindex = ta.Tag
	For i = 0 To clv1.Size -1
		clv1.GetPanel(i).Color = xui.Color_ARGB(255,210,210,255)
	Next
	is_selected = True
	clv1.GetPanel(selectedindex).Color = xui.Color_Red
End Sub
Private Sub btnadd_Click
	add_item("")	
End Sub
Private Sub btndel_Click
	If is_selected = False Then Return
	clv1.RemoveAt(selectedindex)
	clv1_reindex
End Sub
Private Sub btnclear_Click
	If clv1.Size > 0 Then
		Dim sf As Object = xui.Msgbox2Async("Clear the list?", "Title", "Yes", "", "No", Null)
		Wait For (sf) Msgbox_Result (Result As Int)
		If Result = xui.DialogResponse_Positive Then
			clv1.Clear
			itemcnt = 0
			lblfilename.Text = ""
		End If
	End If
End Sub
Private Sub btnload_Click
	fchoose.InitialDirectory = codefolder
	fchoose.SetExtensionFilter("Textfiles",Array As String("*.txt"))
	Dim filename As String = fchoose.ShowOpen(B4XPages.GetNativeParent(B4XPages.MainPage))
	If filename <> "" Then
		Dim path As String = filename.SubString2(0,filename.LastIndexOf("\"))
		Dim fname As String = filename.SubString(filename.LastIndexOf("\")+1)
		lblfilename.Text = fname
		Dim lst As List
		lst.Initialize
		lst = File.ReadList(path,fname)
		clv1.Clear
		itemcnt = 0
		For i = 0 To lst.Size -1
			Dim str As String = lst.Get(i)
			str = str.Replace("||",Chr(10))
			add_item(str)
		Next
	End If
End Sub
Private Sub btnsave_Click
	Dim lst As List
	lst.Initialize
	For i = 0 To clv1.Size -1
		Dim str As String = clv1.GetPanel(i).GetView(0).Text
		str = str.Replace(Chr(10),"||")
		lst.Add(str)
	Next
	fchoose.InitialFileName = "code_snippets.txt"
	fchoose.InitialDirectory = codefolder
	fchoose.SetExtensionFilter("Textfiles",Array As String("*.txt"))
	Dim filename As String = fchoose.ShowSave(B4XPages.GetNativeParent(B4XPages.MainPage))
	If filename <> "" Then
		Dim path As String = filename.SubString2(0,filename.LastIndexOf("\"))
		Dim fname As String = filename.SubString(filename.LastIndexOf("\")+1)
		File.WriteList(path,fname,lst)
	End If
End Sub
Private Sub btngo_Click
	Dim btn As Button = Sender
	Dim gotag As Int = btn.Tag
	If is_selected = False Then
		xui.MsgboxAsync("Select the text first!" & CRLF & "(click in the text area)","Find/Replace")
		reset_textfields
		Return
	End If
	Dim tatext As String = clv1.GetPanel(selectedindex).GetView(0).Text
	tffind.Text = clv1.GetPanel(selectedindex).GetView(1).Text
	tfreplace.Text = clv1.GetPanel(selectedindex).GetView(3).Text
	If gotag <> selectedindex Then
		xui.MsgboxAsync("Select the text first!" & CRLF & "(click in the text area)","Find/Replace")
		reset_textfields
		Return
	End If
	If tffind.Text <> "" And tfreplace.Text <> "" And gotag = selectedindex Then
		If tatext.IndexOf(tffind.Text) = -1 Then
			xui.MsgboxAsync("The variable name was not found.","Find/Replace")
			reset_textfields
			Return
		End If
		tatext = tatext.Replace(tffind.Text,tfreplace.Text)
		clv1.GetPanel(selectedindex).GetView(0).Text = tatext
		reset_textfields
	Else
		xui.MsgboxAsync("One of the fields is empty.","Find/Replace")
		reset_textfields		
	End If
End Sub
Private Sub reset_textfields
	tffind.Text = ""
	tfreplace.Text = ""
	clv1.GetPanel(selectedindex).GetView(1).Text = ""
	clv1.GetPanel(selectedindex).GetView(3).Text = ""
End Sub
